import 'package:contentsquare/src/james_dean2936.dart';
import 'package:flutter/widgets.dart';

import 'package:contentsquare/src/harrison_ford2927.dart';

/// A [ReliableTarget] is a widget that can be used to reliably target widgets
class ReliableTarget extends SingleChildRenderObjectWidget
    with michael_douglas483 {
  /// The identifier of this ReliableTarget.
  final String name;

  /// Creates a [ReliableTarget].
  const ReliableTarget({
    Key? key,
    required Widget child,
    required this.name,
  })  : assert(
          name.length > 0,
          'The name of ReliableTarget should NOT be empty',
        ),
        super(key: key, child: child);

  @override
  RenderObject createRenderObject(BuildContext context) {
    return hugh_jackman468();
  }
}
