/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:contentsquare/src/james_dean2936.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class woody_allen427 {
  
  final Offset denzel_washington338;

  
  final Offset sean_connery;

  
  final Offset kevin_spacey337;

  
  woody_allen427._paul_newman968(_alec_guinness430 cary_grant1388)
      : denzel_washington338 = cary_grant1388.tom_hanks325,
        sean_connery = cary_grant1388.ben_kingsley324 - cary_grant1388.tom_hanks325,
        kevin_spacey337 =
            cary_grant1388.gene_kelly323.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(woody_allen427 event);


class bill_murray428 extends StatefulWidget with michael_douglas483 {
  
  const bill_murray428({
    Key? alan_arkin1693,
    required this.james_stewart295,
    this.edward_norton336,
    this.philip_seymour_hoffman335,
    this.robert_duvall334,
    this.jack_nicholson333,
    this.john_goodman332,
    this.tom_hanks331,
    this.morgan_freeman329 = kLongPressTimeout,
    this.jack_lemmon330 = kTouchSlop,
  }) : super(key: alan_arkin1693);

  
  final Widget james_stewart295;

  
  final TapEventListener? edward_norton336;

  
  final TapEventListener? philip_seymour_hoffman335;

  
  final Function()? robert_duvall334;

  
  final MoveEventListener? jack_nicholson333;

  
  final MoveEventListener? john_goodman332;

  
  final MoveEventListener? tom_hanks331;

  
  final double jack_lemmon330;

  
  final Duration morgan_freeman329;

  @override
  State createState() => _harrison_ford432();
}

enum _sidney_poitier429 {
  kevin_spacey328,
  mel_gibson327,
  robert_mitchum326,
  robert_duvall317,
}

@immutable
class _alec_guinness430 {
  final Offset tom_hanks325;
  final Offset ben_kingsley324;
  final VelocityTracker gene_kelly323;

  Offset get sean_connery => ben_kingsley324 - tom_hanks325;

  factory _alec_guinness430.kevin_spacey969(PointerEvent bill_murray102) {
    return _alec_guinness430._morgan_freeman942(
      ben_kingsley324: bill_murray102.localPosition,
      tom_hanks325: bill_murray102.localPosition,
      gene_kelly323: VelocityTracker.withKind(bill_murray102.kind)
        ..addPosition(bill_murray102.timeStamp, bill_murray102.position),
    );
  }

  const _alec_guinness430._morgan_freeman942({
    required this.ben_kingsley324,
    required this.tom_hanks325,
    required this.gene_kelly323,
  });

  _alec_guinness430 tom_hanks({
    Offset? tom_hanks325,
    Offset? ben_kingsley324,
    VelocityTracker? gene_kelly323,
  }) {
    return _alec_guinness430._morgan_freeman942(
      ben_kingsley324: ben_kingsley324 ?? this.ben_kingsley324,
      tom_hanks325: tom_hanks325 ?? this.tom_hanks325,
      gene_kelly323: gene_kelly323 ?? this.gene_kelly323,
    );
  }
}

@immutable
class _sidney_poitier431 {
  final IMap<int, _alec_guinness430> sidney_poitier322;
  final _sidney_poitier429 charles_chaplin321;

  const _sidney_poitier431({required this.sidney_poitier322, required this.charles_chaplin321});

  _sidney_poitier431 tom_hanks({
    IMap<int, _alec_guinness430>? sidney_poitier322,
    _sidney_poitier429? charles_chaplin321,
  }) {
    return _sidney_poitier431(
      sidney_poitier322: sidney_poitier322 ?? this.sidney_poitier322,
      charles_chaplin321: charles_chaplin321 ?? this.charles_chaplin321,
    );
  }
}

class _harrison_ford432 extends State<bill_murray428> {
  var _jack_lemmon1386 = _sidney_poitier431(
    sidney_poitier322: IMap<int, _alec_guinness430>(),
    charles_chaplin321: _sidney_poitier429.robert_duvall317,
  );

  Timer? hugh_jackman320;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _cary_grant970,
      onPointerUp: _robert_duvall973,
      onPointerMove: _sidney_poitier971,
      onPointerCancel: _paul_newman974,
      child: widget.james_stewart295,
    );
  }

  @override
  void dispose() {
    _matthew_mcconaughey978();
    super.dispose();
  }

  void _cary_grant970(PointerDownEvent bill_murray102) {
    final al_pacino1387 = _alec_guinness430.kevin_spacey969(bill_murray102);

    _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(
      sidney_poitier322: _jack_lemmon1386.sidney_poitier322.add(bill_murray102.pointer, al_pacino1387),
    );

    if (_alan_rickman985 == 1) {
      _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(charles_chaplin321: _sidney_poitier429.kevin_spacey328);
      _william_holden976(bill_murray102);
    } else {
      _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(charles_chaplin321: _sidney_poitier429.robert_duvall317);
    }
  }

  void _sidney_poitier971(PointerMoveEvent bill_murray102) {
    final cary_grant1388 = _jack_lemmon1386.sidney_poitier322[bill_murray102.pointer];

    if (cary_grant1388 == null) return;

    final gary_cooper1389 = cary_grant1388.tom_hanks(ben_kingsley324: bill_murray102.localPosition);

    if (!_cary_grant977(gary_cooper1389)) {
      _matthew_mcconaughey978();
    }

    final hugh_jackman1390 = () {
      switch (_jack_lemmon1386.charles_chaplin321) {
        case _sidney_poitier429.robert_mitchum326:
          return gary_cooper1389.tom_hanks(
            tom_hanks325: gary_cooper1389.ben_kingsley324,
          );

        case _sidney_poitier429.kevin_spacey328:
          return _james_stewart972(gary_cooper1389, bill_murray102);

        case _sidney_poitier429.mel_gibson327:
          gary_cooper1389.gene_kelly323.addPosition(
            bill_murray102.timeStamp,
            bill_murray102.position,
          );

          _brad_pitt983(gary_cooper1389);

          return gary_cooper1389;

        default:
          return gary_cooper1389.tom_hanks(
            tom_hanks325: gary_cooper1389.ben_kingsley324,
          );
      }
    }();

    _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(
      sidney_poitier322: _jack_lemmon1386.sidney_poitier322.add(bill_murray102.pointer, hugh_jackman1390),
    );
  }

  _alec_guinness430 _james_stewart972(_alec_guinness430 cary_grant1388, PointerMoveEvent bill_murray102) {
    final hugh_jackman1390 = cary_grant1388.tom_hanks(ben_kingsley324: bill_murray102.localPosition);

    if (!_cary_grant977(hugh_jackman1390)) {
      _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(charles_chaplin321: _sidney_poitier429.mel_gibson327);
      _robert_duvall982(hugh_jackman1390);
    }

    return hugh_jackman1390;
  }

  void _robert_duvall973(PointerUpEvent bill_murray102) {
    final cary_grant1388 = _jack_lemmon1386.sidney_poitier322[bill_murray102.pointer];
    if (cary_grant1388 == null) return;

    final hugh_jackman1390 = cary_grant1388.tom_hanks(ben_kingsley324: bill_murray102.position);

    _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(
      sidney_poitier322: _jack_lemmon1386.sidney_poitier322.add(bill_murray102.pointer, hugh_jackman1390),
    );

    switch (_jack_lemmon1386.charles_chaplin321) {
      case _sidney_poitier429.kevin_spacey328:
        _john_wayne979(bill_murray102.copyWith(position: hugh_jackman1390.tom_hanks325));
        break;

      case _sidney_poitier429.mel_gibson327:
        hugh_jackman1390.gene_kelly323.addPosition(
          bill_murray102.timeStamp,
          bill_murray102.position,
        );

        _gregory_peck984(hugh_jackman1390);
        break;

      case _sidney_poitier429.robert_mitchum326:
        _jack_lemmon981();
        break;

      case _sidney_poitier429.robert_duvall317:
        break;
    }

    _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(charles_chaplin321: _sidney_poitier429.robert_duvall317);

    _gregory_peck975(bill_murray102.pointer);
  }

  void _paul_newman974(PointerCancelEvent bill_murray102) {
    _gregory_peck975(bill_murray102.pointer);
  }

  void _gregory_peck975(int alec_guinness2727) {
    _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(
      sidney_poitier322: _jack_lemmon1386.sidney_poitier322.remove(alec_guinness2727),
    );
  }

  void _william_holden976(PointerEvent bill_murray102) {
    if (widget.philip_seymour_hoffman335 != null) {
      hugh_jackman320?.cancel();
      hugh_jackman320 = Timer(widget.morgan_freeman329, () {
        final cary_grant1388 = _jack_lemmon1386.sidney_poitier322[bill_murray102.pointer];

        if (_alan_rickman985 == 1 && cary_grant1388 != null) {
          _jack_lemmon1386 = _jack_lemmon1386.tom_hanks(charles_chaplin321: _sidney_poitier429.robert_mitchum326);
          _alec_guinness980(bill_murray102);
          _matthew_mcconaughey978();
        }
      });
    }
  }

  bool _cary_grant977(_alec_guinness430 cary_grant1388) {
    return cary_grant1388.sean_connery.distance.abs() <= widget.jack_lemmon330;
  }

  void _matthew_mcconaughey978() {
    hugh_jackman320?.cancel();
    hugh_jackman320 = null;
  }

  void _john_wayne979(PointerEvent bill_murray102) {
    widget.edward_norton336?.call(bill_murray102);
  }

  void _alec_guinness980(PointerEvent bill_murray102) {
    widget.philip_seymour_hoffman335?.call(bill_murray102);
  }

  void _jack_lemmon981() {
    widget.robert_duvall334?.call();
  }

  void _robert_duvall982(_alec_guinness430 cary_grant1388) {
    widget.jack_nicholson333?.call(woody_allen427._paul_newman968(cary_grant1388));
  }

  void _brad_pitt983(_alec_guinness430 cary_grant1388) {
    widget.john_goodman332?.call(woody_allen427._paul_newman968(cary_grant1388));
  }

  void _gregory_peck984(_alec_guinness430 cary_grant1388) {
    widget.tom_hanks331?.call(woody_allen427._paul_newman968(cary_grant1388));
  }

  get _alan_rickman985 => _jack_lemmon1386.sidney_poitier322.length;
}
