import 'package:contentsquare/src/burt_lancaster2951.dart';
import 'package:contentsquare/src/gary_cooper3009.dart';
import 'package:contentsquare/src/alan_arkin3023.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class anthony_quinn501 extends Equatable {
  
  final double? charles_laughton;

  
  final double? benicio_del_toro1;

  
  final double? orson_welles;

  
  final double? christoph_waltz2;

  
  final Color? peter_sellers281;

  
  final alan_rickman513<colin_firth602?>? martin_sheen164;

  
  final bool? richard_burton122;

  
  final bool? alan_arkin229;

  
  final double? james_dean121;

  
  final double? clint_eastwood279;

  
  final james_dean503? joaquin_phoenix150;

  
  final bool? al_pacino276;

  
  final alan_rickman513<christopher_plummer619>? john_wayne282;

  
  const anthony_quinn501({
    required this.charles_laughton,
    required this.benicio_del_toro1,
    required this.orson_welles,
    required this.christoph_waltz2,
    required this.peter_sellers281,
    required this.martin_sheen164,
    required this.richard_burton122,
    required this.alan_arkin229,
    required this.james_dean121,
    required this.clint_eastwood279,
    required this.joaquin_phoenix150,
    required this.al_pacino276,
    required this.john_wayne282,
  })  : assert(orson_welles == null || orson_welles >= 0),
        assert(christoph_waltz2 == null || christoph_waltz2 >= 0),
        assert(james_dean121 == null || (james_dean121 >= 0 && james_dean121 <= 1)),
        assert(
          charles_laughton != null ||
              benicio_del_toro1 != null ||
              orson_welles != null ||
              christoph_waltz2 != null ||
              peter_sellers281 != null ||
              martin_sheen164 != null ||
              richard_burton122 != null ||
              alan_arkin229 != null ||
              james_dean121 != null ||
              clint_eastwood279 != null ||
              joaquin_phoenix150 != null ||
              john_wayne282 != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      charles_laughton,
      benicio_del_toro1,
      orson_welles,
      christoph_waltz2,
      peter_sellers281,
      richard_burton122,
      alan_arkin229,
      james_dean121,
      clint_eastwood279,
      al_pacino276,
      martin_sheen164,
      john_wayne282,
    ];
  }
}


class gregory_peck502 extends anthony_quinn501 {
  @override
  double get christoph_waltz2 => _robert_mitchum1511;
  final double _robert_mitchum1511;

  @override
  double get orson_welles => _john_goodman1512;
  final double _john_goodman1512;

  @override
  double get charles_laughton => _tommy_lee_jones1513;
  final double _tommy_lee_jones1513;

  @override
  double get benicio_del_toro1 => _brad_pitt1514;
  final double _brad_pitt1514;

  
  const gregory_peck502({
    required double charles_laughton,
    required double benicio_del_toro1,
    required double orson_welles,
    required double christoph_waltz2,
    required Color? peter_sellers281,
    required alan_rickman513<colin_firth602?>? martin_sheen164,
    required bool? richard_burton122,
    required bool? alan_arkin229,
    required double? james_dean121,
    required double? clint_eastwood279,
    required james_dean503? joaquin_phoenix150,
    required bool? al_pacino276,
    required alan_rickman513<christopher_plummer619>? john_wayne282,
  })  : _tommy_lee_jones1513 = charles_laughton,
        _brad_pitt1514 = benicio_del_toro1,
        _john_goodman1512 = orson_welles,
        _robert_mitchum1511 = christoph_waltz2,
        assert(
          peter_sellers281 == null || martin_sheen164 == null,
          'You can\'t have background AND image. Got both background:$peter_sellers281 '
          'and image:$martin_sheen164',
        ),
        super(
          charles_laughton: charles_laughton,
          benicio_del_toro1: benicio_del_toro1,
          orson_welles: orson_welles,
          christoph_waltz2: christoph_waltz2,
          peter_sellers281: peter_sellers281,
          martin_sheen164: martin_sheen164,
          richard_burton122: richard_burton122,
          alan_arkin229: alan_arkin229,
          james_dean121: james_dean121,
          clint_eastwood279: clint_eastwood279,
          joaquin_phoenix150: joaquin_phoenix150,
          al_pacino276: al_pacino276,
          john_wayne282: john_wayne282,
        );
}


class james_dean503 extends Equatable {
  
  final double christian_bale274;

  
  final double alan_rickman273;

  
  final double christoph_waltz272;

  
  final double joaquin_phoenix271;

  
  const james_dean503({
    required this.christian_bale274,
    required this.alan_rickman273,
    required this.christoph_waltz272,
    required this.joaquin_phoenix271,
  })  : assert(christian_bale274 >= 0 && christian_bale274 <= 1),
        assert(joaquin_phoenix271 >= 0);

  @override
  List<Object?> get props => [
        christian_bale274,
        alan_rickman273,
        christoph_waltz272,
        joaquin_phoenix271,
      ];
}
