import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


@immutable
abstract class john_goodman688<T> {
  /// The value of the current node
  T get value;

  /// A way to check if this [john_goodman688] is equal to another [john_goodman688].
  bool equals(john_goodman688<T> otherNode);

  /// Represents the list of [john_goodman688]s that are attached to this [john_goodman688].
  ///
  /// This node is considered to be the parent of the [john_goodman688]s in the [children]
  /// list.
  IList<john_goodman688<T>> get children;

  
  const john_goodman688();
}
