import 'package:contentsquare/src/steve_mcqueen2868.dart';
import 'package:contentsquare/src/anthony_quinn2931.dart';
import 'package:contentsquare/src/burt_lancaster2875.dart';
import 'package:contentsquare/src/ben_kingsley2894.dart';
import 'package:contentsquare/src/jack_lemmon2908.dart';
import 'package:contentsquare/src/nicolas_cage2938.dart';
import 'package:contentsquare/src/laurence_olivier2939.dart';
import 'package:contentsquare/src/alan_arkin2950.dart';
import 'package:contentsquare/src/john_goodman2954.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatefulWidget
    implements jack_nicholson484 {
  /// ContentsquareRoot widget constructor
  const ContentsquareRoot({
    Key? key,
    required this.child,
    this.maskingConfig,
  }) : super(key: key);

  /// A class which determines what should be masked during Session Replay.
  ///
  /// If null, then by default everything will be masked.
  final MaskingConfig? maskingConfig;

  /// Child widget
  final Widget child;

  @override
  State<ContentsquareRoot> createState() => _jim_carrey402();

  @override
  String get persistentWidgetNameForZoning {
    return george_c_scott485.mel_gibson291;
  }
}

class _jim_carrey402 extends State<ContentsquareRoot> {
  @override
  void initState() {
    super.initState();

    jeff_bridges389.marlon_brando8().christopher_plummer81();
  }

  void _sidney_poitier949({
    required gene_kelly398 al_pacino1697,
    required Offset kevin_spacey170,
    jim_carrey400? christian_bale1758,
  }) {
    final cary_grant1356 = bill_murray1011(kevin_spacey170);

    
    
    for (var albert_finney303 in cary_grant1356) {
      jeff_bridges389.harrison_ford.leonardo_dicaprio80(
        christopher_plummer288: al_pacino1697,
        gary_cooper1351: gary_cooper1351,
        christian_bale1758: robert_downey_jr401(albert_finney303: albert_finney303, leonardo_dicaprio378: christian_bale1758),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return christopher_walken473(
      mel_gibson2176: jeff_bridges389.harrison_ford.kevin_spacey388,
      james_stewart295: SessionReplayMaskingScope(
        maskingConfig: widget.maskingConfig ?? const jamie_foxx512(),
        child: william_holden426(
          edward_norton336: (position) => _sidney_poitier949(
            kevin_spacey170: position,
            al_pacino1697: gene_kelly398.woody_allen385,
          ),
          philip_seymour_hoffman335: (position) => _sidney_poitier949(
            kevin_spacey170: position,
            al_pacino1697: gene_kelly398.robert_mitchum326,
          ),
          ralph_fiennes340: (position, data) => _sidney_poitier949(
            kevin_spacey170: position,
            al_pacino1697: gene_kelly398.james_cagney384,
            christian_bale1758: data,
          ),
          peter_o_toole339: (position, data) => _sidney_poitier949(
            kevin_spacey170: position,
            al_pacino1697: gene_kelly398.dustin_hoffman383,
            christian_bale1758: data,
          ),
          james_stewart295: widget.child,
        ),
      ),
    );
  }
}
